<!--
 * @Date: 2025-06-18 09:17:09
 * @LastEditors: gaoshp
 * @LastEditTime: 2025-07-20 20:48:15
 * @FilePath: /mdmweb/src/views/flowmgr/processQuery.vue
-->
<template>
    <basic-container>
        <avue-crud :option="option" :table-loading="loading" :data="data" v-model:page="page" v-model="form" ref="crud"
            @search-change="searchChange" @search-reset="searchReset" @current-change="currentChange"
            @size-change="sizeChange" @refresh-change="refreshChange" @on-load="onLoad" @selection-change="selectionChange">
            <template #menu-left>
                <!-- <el-button type="primary" plain @click="exportWebSite">导出回传涉密网</el-button> -->
                <!-- <el-button type="primary" plain @click="reassign">挂载车床程序库</el-button> -->
                <!-- <el-button type="primary" plain @click="exportExcel">导出到EXCEL</el-button> -->
            </template>
            <template #menu="scope">
                <el-button type="danger" text size="default"
                    @click.stop="handleAction(scope.row, scope.index, 0)">删除
                </el-button>
            </template>
        </avue-crud>
    </basic-container>
</template>

<script>
import { getList, deleteRow } from '@/api/flowmgr/processQuery.js';
import { exportBlob } from '@/api/common';
import { getToken } from '@/utils/auth';
import NProgress from 'nprogress';
import { downloadXls } from '@/utils/util';
import 'nprogress/nprogress.css';
export default {
    name: 'MachineReturnFileOp',
    data() {
        return {
            page: {
                pageSize: 10,
                currentPage: 1,
                total: 0,
            },
            form: {},
            query: {},
            loading: true,
            data: [],
            option: {
                addBtn: false,
                editBtn: false,
                delBtn: false,
                viewBtn: true,
                columnBtn: false,
                tip: false,
                // simplePage: true,
                searchShow: true,
                searchMenuSpan: 6,
                dialogWidth: '60%',
                // tree: true,
                border: true,
                index: true,
                selection: true,
                
                menuWidth: 200,
                // menu: false,
                dialogClickModal: false,
                column: [
                    {
                        label: '流程类型',
                        prop: '',
                        search: true,
                        searchType: 'select',
                        hide: true,
                        dicUrl: `/blade-system/dict/dictionary?code=flow`,
                        props: {
                            label: 'dictValue',
                            value: 'dictKey',
                        },
                    },
                    {
                        label: '创建时间',
                        prop: 'createTime',
                        type: 'datetime',
                        format: 'YYYY-MM-DD HH:mm:ss',
                        valueFormat: 'YYYY-MM-DD HH:mm:ss',
                        search: true,
                        searchRange: true,
                        hide: true,
                    },
                    {
                        label: '关键字',
                        prop: 'keyword',
                        search: true,
                        searchType: 'input',
                        hide: true,
                    },
                    {
                        label: '流程模版',
                        prop: '',
                    },
                    {
                        label: '机床',
                        prop: '',
                    },
                    {
                        label: '标题',
                        prop: '',
                    },
                    {
                        label: '创建人',
                        prop: 'startUserName',
                    },
                    {
                        label: '编制',
                        prop: '',
                    },
                    {
                        label: '工序名称',
                        prop: '',
                    },
                    {
                        label: '加工车间',
                        prop: '',
                    },
                    {
                        label: '创建时间',
                        prop: 'processCreateTime',
                    },
                    {
                        label: '当前节点',
                        prop: 'taskName',
                    },
                ],
                selectedList: [],
            }
        }
    },
    methods: {
        handleAction (row, index, flag) {
            // 处理接受或拒绝操作
            let ids = [row.id].toString();
            this.$confirm('确定将选择数据删除?', {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
                type: 'warning',
            })
            .then(() => {
                deleteRow({processInstanceId: row.processInstanceId})
            })
        },
        selectionChange (list) {
            this.selectedList = list;
        },
        // exportWebSite() {
        //     if (this.selectedList.length === 0) {
        //         this.$message.warning('请先选择需要导出的数据');
        //         return;
        //     }
        //     this.$confirm('是否导出?', '提示', {
        //         confirmButtonText: '确定',
        //         cancelButtonText: '取消',
        //         type: 'warning',
        //     }).then(() => {
        //         NProgress.start();
        //         exportBlob(
        //             `/blade-mdm/machineback/filehandle/export-to-inner`,
        //             {
        //                 ids: this.selectedList.map(item => item.id).join(','),
        //             }
        //         ).then(res => {
        //             downloadXls(res.data, `导出回传涉密网${this.$dayjs().format('YYYY-MM-DD HH:mm:ss')}.xlsx`);
        //             NProgress.done();
        //         });
        //     });
        // },
        // exportExcel() {
        //     if (this.selectedList.length === 0) {
        //         this.$message.warning('请先选择需要导出的数据');
        //         return;
        //     }
        //     this.$confirm('是否导出?', '提示', {
        //         confirmButtonText: '确定',
        //         cancelButtonText: '取消',
        //         type: 'warning',
        //     }).then(() => {
        //         NProgress.start();
        //         exportBlob(
        //             `/blade-mdm/machineback/filehandle/export-excel?${this.website.tokenHeader}=${getToken()}`
        //         ).then(res => {
        //             downloadXls(res.data, `导出机床回传程序${this.$dayjs().format('YYYY-MM-DD HH:mm:ss')}.xlsx`);
        //             NProgress.done();
        //         });
        //     });
        // },
        searchChange(params, done) {
            let data = {}
            this.query = params;
            this.page.currentPage = 1;
            console.log('searchChange', params);
            params.createTimeBegin = params?.createTime?.[0] || '';
            params.createTimeEnd = params?.createTime?.[1] || '';
            console.log(params);
            // data = {
            //     createTimeBegin: dayjs(params.createTimeBegin).isValid() ? dayjs(params.createTimeBegin).format('YYYY-MM-DD') : '',
            //     createTimeEnd: dayjs(params.createTimeEnd).isValid() ? dayjs(params.createTimeEnd).format('YYYY-MM-DD') : '',
            //     keyword: params.keyword || ''
            // }
            data = {
                createTimeBegin: params.createTimeBegin,
                createTimeEnd: params.createTimeEnd,
            }
            this.query = data
            this.onLoad(this.page, data);
            done();
        },
        searchReset() {
            let data = {}
            this.query = params;
            this.page.currentPage = 1;
            data = {
                createTimeBegin: params.createTimeBegin,
                createTimeEnd: params.createTimeEnd,
                keyword: params.keyword || ''
            }
            this.onLoad(this.page, data);
            done();
        },
        currentChange(currentPage) {
            this.page.currentPage = currentPage;
            // this.onLoad();
        },
        sizeChange(pageSize) {
            this.page.pageSize = pageSize;
        },
        refreshChange() {
            this.onLoad(this.page, this.query);
        },
        /** * 页面加载时获取数据
         */
        onLoad(page, params = {}) {
            console.log('onLoad', page, params);
            const query = {
                ...this.query,
                // category: params.category ? flowCategory(params.category) : null,
                mode: this.mode,
            };
            try {
                delete query.confirmTime; // 删除不必要的查询条件
            } catch (error) {
                console.error('日期格式化错误', error);
            }

            this.loading = true;
            getList(page.currentPage, page.pageSize, Object.assign(query, params)).then(res => {
                const data = res.data.data;
                this.page.total = data.total;
                this.data = data.records;
                this.loading = false;
            }, () => {
                this.data = [];
                this.loading = false;
            }).catch(err => {
                this.data = [];
                this.loading = false;
            });
        }
    }
};
</script>

<style lang="scss" scoped></style>